/*
 ==============================================================================
      BLC-100 Tv[UvO
 ==============================================================================
*/

#include	<stdio.h>
#include	<string.h>

#include	"BiosIf.h"

#define	VER		1
#define	REV		0

#define	TRUE	1
#define	FALSE	0

#define	OK		1

#define	ON		1
#define	OFF		0

#define	DTR		1

void	main(int);

static	const	struct	{				/* vÕwb_ */
	char	Name[13];					/* vO̖ */
	char	dmy;
	char	Ver;						/* o[Wԍij */
	char	Rev;						/* o[Wԍij */
	int		size;						/* vOTCY(64koCgP) */
	void	(*func)(int);				/* Gg[`̃AhX */
} Dir = {
	"Sample",							/* ̕uNvOv*/
	0,									/* ɐݒ肷B                    */
	VER,								/* o[W1.00ɂȂ */
	REV,								/* o[W1.00ɂȂ */
	0x10000,							/* =64koCg */
	main
};

static	int				SockSv;			/* \PbgT[õvZXID       */
static	unsigned long	CntLR;			/* LANVAf[^JE^      */
static	unsigned long	CntRL;			/* VALANf[^JE^      */
static	int				Full;			/* obt@tM             */

/*****  vbZ[W̑M  ************************************************/
static int put_rq(unsigned char cmd, unsigned long prmlen, char *prm)
{
	TMsg	msg;						/* MbZ[W */

	/*** bZ[W̍쐬 ***/
	msg.dest   = SockSv;				/* ̃vZXID */
	msg.rqrs   = MSG_REQUEST;			/* vbZ[W */
	msg.cmd    = cmd;					/* v */
	msg.prmlen = prmlen;				/* p[^ */
	if(prmlen > 4) {							/* p[^ꍇ͓ */
		if(Malloc(prmlen, &msg.prm) != OK)		/* IɃf[^Zbg */
			return ERR_MEMOVER;					/* B                   */
		memcpy(*msg.prm, prm, prmlen);
	} else										/* p[^Zꍇ̓| */
		if(prm != NULL)							/* C^̗̈ɒlZbg */
			memcpy(&msg.prm, prm, prmlen);		/* B                   */

	if(PutMsg(&msg) != OK) {	/* bZ[WʒmɎsꍇAI */
		if(prmlen > 4)			/* GȀL҂͊mۂvZX̂܂܂ */
			Free(msg.prm);		/* 邽߁AKvB           */
		return ERR_QUEFULL;		/* bZ[WʒmɐꍇAI */
	}							/* GȀL҂͒ʒm̃vZXɕύX */
								/* B                                   */

	return OK;
}

/*****  [`  ******************************************************/
static void init(int aPid)
{
	int	rsp[3];							/* RS-232Cݒ擾GA */
	int	get_stat;						/* Ԏ擾bZ[W̃p[^ */

	B_Init(aPid);						/* BIOS ̏ */
	TrInit();							/* TELNET T[őN */

	GetParam(rsp, 1);					/* RS-232C ݒ̎擾 */
	RsOpen(rsp);						/* RS-232C I[v */
	RsSetCtrl(DTR, OFF);				/* DTR  OFF ɂ */

	SockSv = Exec("SockSv");			/* \PbgT[őN */
	put_rq(MSG_GETDATA, 0, NULL);		/* f[^v\PbgT[oɒʒm */
	get_stat = 0;						/* Ԏ擾o^\PbgT[oɑ */
	put_rq(MSG_GETSTAT, 4, &get_stat);	/* čs                         */

	/*** ԕϐ̏ ***/
	Full = FALSE;
	CntLR = 0;							/* JE^̏ */
	CntRL = 0;
}

/*****  ڑ  **********************************************************/
static void conn_proc(void)
{
	RsSetCtrl(DTR, ON);					/* DTR  ON ɂ */
	CntLR = 0;							/* JE^NA */
	CntRL = 0;
}

/*****  ؒf  **********************************************************/
static void disconn_proc(void)
{
	char	str[160];

	RsSetCtrl(DTR, OFF);				/* DTR  OFF ɂ */

	/*** JE^̒lTELNETɏo ***/
	sprintf(str, "Disconnected\r\n"
			"Count of Sock to Serial = %d\r\nCount of Serial to Sock = %d\r\n",
			CntLR, CntRL);
	TrOut(str);
}

/*****  VAf[^  **************************************************/
static void rs_data_proc(void)
{
	int		  size;						/* Mf[^oCg         */
	char	**buf;						/* Mf[^GÃ|C^ */

	if(Full == TRUE)					/* LAN MłȂƂ͎M */
		return;							/* Ȃ                             */

	RsGetBuff(&size, NULL, NULL, NULL);	/* obt@̃f[^ʂ擾 */
	if((RsGetCtrl() & 2) == 2) {				/* DTR  ON ̏ꍇA\Pb */
		if(Malloc(size, &buf) == OK) {			/* gT[oɎMf[^ */
			RsRecv(*buf, &size);				/* mB                 */
			if(put_rq(MSG_PUTDATA, size, *buf) == OK)
				CntRL += size;
		}
	} else {									/* DTR  OFF ̏ꍇATELNET */
		if(Malloc(size + 1, &buf) == OK) {		/* ɎMf[^ʒmB  */
			RsRecv(*buf, &size);
			(*buf)[size] = 0;
			TrOut(*buf);
		}
	}
	Free(buf);							/* Mf[^GA */
}

/*****  LANf[^  *******************************************************/
static void lan_data_proc(TMsg *msg)
{
	int	size;							/* Mf[^ */

	if(msg->rqrs != MSG_REQUEST)		/* f[^ʒmȊO͖ */
		return;

	size = msg->prmlen;
	if(msg->prmlen > 4) {				/* TCYɂēnقȂ */
		while(size > 0)					/* SẴf[^𑗐M */
			size -= RsSend(&(*msg->prm)[msg->prmlen-size], size);
		Free(msg->prm);
	} else {
		while(size > 0)
			size -= RsSend(&((char *)&msg->prm)[msg->prmlen-size], size);
	}
	CntLR += msg->prmlen;				/* JE^̍XV */
}

/*****  C[`  ******************************************************/
void main(int aPid)
{
	TMsg	msg;						/* MbZ[W */

	init(aPid);							/* [`̌Ăяo */

	for(;;) {							/* [v */
		GetMsg(&msg);					/* Cxg҂ɓ */
		switch(msg.cmd) {
		case MSG_CONNECTED:				/* LAN ̐ڑm */
			conn_proc();
			break;
		case MSG_SVOPENED:				/* LAN ̐ڑؒf */
			disconn_proc();
			break;
		case MSG_SYSMSG:				/* RS-232CɎMf[^ */
			rs_data_proc();
			break;
		case MSG_PUTDATA:				/* LAN ̃f[^M */
			lan_data_proc(&msg);
			break;
		case MSG_BUFFULL:				/* LAN ̑Mobt@ς */
			Full = TRUE;
			break;
		case MSG_BUFREADY:				/* LAN ̑Mobt@ */
			Full = FALSE;
			break;
		default:
			if(msg.prmlen > 4)			/* p[^𖳎 */
				Free(msg.prm);
			msg.dest   = SockSv;				/* R}hΉ̃G[ */
			msg.rqrs   = MSG_ERROR;				/* Ԃ                     */
			msg.prmlen = 4;
			msg.prm    = (char **)(int)msg.cmd;
			msg.cmd    = ERR_MSGCMD;
			PutMsg(&msg);
			break;
		}
	}
}